/* Generic file extractor - Randy C. Finch 1990 
    I typed this in from an article in Amazing Computing. Best way to use it is to copy the archive files to ram: then "cd ram:" and do "rx filextractor". It will find and extract all the archived files in ram: and make the correct directories. Then you can transfer them to disk. It would be easy to add other extraction programs to the set - I have added Lha.  - Don Cox. */

trace r

address command

'list >ram:rcflist files quick'

call open('rcf','ram:rcflist','R')

do until eof('rcf')
    filename = readln('rcf')
    rs = right(filename,4)
    rs = upper(right(filename,4))
    if rs = '.ARC' | rs = '.ZOO' | rs = '.LZH' | rs = '.LHA' then do
        ls = left(filename,length(filename)-4)
        'makedir ' ls
/* CD must be inline with command */
/* Current dir of calling shell will not change */
        prefix = 'cd 'ls'0a'x
        select
            when rs = '.ARC' then prefix 'arc x /'ls'.arc'
            when rs = '.ZOO' then prefix 'zoo x /'ls'.zoo'
            when rs = '.LZH' then prefix 'lha -x x /'ls'.lzh'
            when rs = '.LHA' then prefix 'lha -x x /'ls'.lha'
            end
        end
    end

call close('rcf')
'delete ram:rcflist'
exit